<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>

<%@page contentType="text/html" pageEncoding="UTF-8" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.endpoint.tos.xsd.*" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.endpoint.ui.client.EndpointAdminClient" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="java.util.ResourceBundle" %>
<%@ page import="java.util.Locale" %>
<%@ page import="java.util.MissingResourceException" %>
<%@ page import="javax.xml.stream.XMLStreamException" %>
<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.apache.axiom.om.impl.llom.util.AXIOMUtil" %>
<%@ page import="org.apache.synapse.endpoints.WSDLEndpoint" %>
<%@ page import="org.apache.synapse.config.xml.endpoints.EndpointFactory" %>
<%@ page import="org.wso2.carbon.endpoint.ui.util.EndpointConfigurationHelper" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<!-- Dependencies -->
<script type="text/javascript" src="../yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="../yui/build/container/container_core-min.js"></script>

<!-- Connection handling lib -->
<script type="text/javascript" src="../yui/build/yahoo/yahoo-min.js"></script>
<script type="text/javascript" src="../yui/build/event/event-min.js"></script>
<script type="text/javascript" src="../yui/build/connection/connection-min.js"></script>
<script type="text/javascript" src="../resources/js/resource_util.js"></script>
<script type="text/javascript" src="../ajax/js/prototype.js"></script>
<!-- Source File -->

<script type="text/javascript" src="../yui/build/menu/menu-min.js"></script>

<link type="text/css" rel="stylesheet" href="css/style.css"/>
<link rel="stylesheet" type="text/css" href="../resources/css/registry.css"/>

<fmt:bundle basename="org.wso2.carbon.endpoints.ui.i18n.Resources">
<carbon:jsi18n
        resourceBundle="org.wso2.carbon.endpoints.ui.i18n.Resources"
        request="<%=request%>"/>
<carbon:breadcrumb
        label="wsdl.endpoint"
        resourceBundle="org.wso2.carbon.endpoints.ui.i18n.Resources"
        topPage="false"
        request="<%=request%>"/>

<%
    WSDLEndpointData wsdlEpData = null;
    String[] actionOptions = {"neverTimeout", "discardMessage", "executeFaultSequence"};

    ResourceBundle bundle = ResourceBundle.getBundle("org.wso2.carbon.sequences.ui.i18n.Resources", request.getLocale());
    String url = CarbonUIUtil.getServerURL(this.getServletConfig().getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().
                    getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    EndpointAdminClient adminClient = new EndpointAdminClient(cookie, url, configContext);

    String endpointName = request.getParameter("endpointName");
    String endpointAction = request.getParameter("endpointAction");
    String design = request.getParameter("design");

    String endpointMode = null; // this holds an annonymos endpoint which can come trough proxy and send mediator
    String anonymouseOriginator = null;
    boolean isAnonymous = false;
    String anonymousEndpointXML = null;
    endpointMode = (String) session.getAttribute("epMode");
    if (endpointMode != null && "anon".equals(endpointMode)) {
        isAnonymous = true;
    }

    // coming through index.jsp by clicking the 'edit' link
    if (endpointAction != null && !"".equals(endpointAction) && endpointAction.equals("edit")) {
        session.setAttribute("edit" + endpointName, "edit");
        try {
            wsdlEpData = adminClient.getWSDLEndpoint(endpointName);
        } catch (Exception e) {
            String msg = "Unable to get WSDL endpoint data: " + e.getMessage();
            CarbonUIMessage.sendCarbonUIMessage(msg, CarbonUIMessage.ERROR, request);
        }
    } else if (design != null && !"".equals(design)) {
        // coming through source view using switchToDesign
        OMElement element = null;
        try {
            element = AXIOMUtil.stringToOM(design);
            WSDLEndpoint wsdlEp = (WSDLEndpoint) EndpointFactory.getEndpointFromElement(element, false);
            wsdlEpData = EndpointConfigurationHelper.getWSDLEpFromSynEp(wsdlEp, session, isAnonymous);
        } catch (XMLStreamException e) {
            String msg = "Unable to get WSDL endpoint data: " + e.getMessage();
            CarbonUIMessage.sendCarbonUIMessage(msg, CarbonUIMessage.ERROR, request);
        } catch (Exception e) {
            String msg = "Unable to get WSDL endpoint data: " + e.getMessage();
            CarbonUIMessage.sendCarbonUIMessage(msg, CarbonUIMessage.ERROR, request);
        }
    } else if (isAnonymous) {
        // coming through using either send mediator or proxy services by adding an annonymous endpoint
        //we are in anonymous mode
        if (anonymousEndpointXML != null && !"".equals(anonymousEndpointXML)) {
            // if a user is here that mean user is trying to edit an existing anoymous endpoint
            try {
                wsdlEpData = EndpointAdminClient.
                        getWsdlEndpointData(anonymousEndpointXML);
            } catch (Exception e) {
                session.removeAttribute("anonEpXML");
%>
<script type="text/javascript">
    CARBON.showErrorDialog("Unable to create endpoint with given data");
    window.location.href = "WSDLEndpoint.jsp";
</script>
<%
            }
        }
    }

    String wsdlEpName = "";
    boolean isInlineWSDL = false;
    String wsdlURI = "";
    String inlineWSDl = "";
    String service = "";
    String errorCode = "";
    long suspendDurationOnFailure = 0;
    long maxDuration = 0;
    String port = "";
    String timeOutErrorCode = "";
    double factor = 1.0; // default value
    int retryTimeOut = 0;
    int retryDelayTimeOut = 0;
    boolean isNeverTimeout = true, isDiscardMessage = false, isFaultSequence = false;
    long actionDuration = 0;
    boolean isEnableAddressing = false;
    boolean isSepListener = false;
    boolean isEnableWSSec = false;
    String secPolicy = "";
    boolean isEnableRM = false;
    String rmPolicy = "";

    if (wsdlEpData != null) {

        // Endpoint Name
        if (wsdlEpData.getEpName() != null) {
            wsdlEpName = wsdlEpData.getEpName();
        }

        // Inline WSDL ?
        if (wsdlEpData.getInLineWSDL() != null &&
                !"".equals(wsdlEpData.getInLineWSDL())) {
            isInlineWSDL = true;
            inlineWSDl = wsdlEpData.getInLineWSDL();
        } else {
            isInlineWSDL = false;
            if (wsdlEpData.getEpUri() != null) {
                wsdlURI = wsdlEpData.getEpUri();
            }
        }

        // Service
        if (wsdlEpData.getEpServ() != null) {
            service = wsdlEpData.getEpServ();
        }

        // Port
        if (wsdlEpData.getEpPort() != null) {
            port = wsdlEpData.getEpPort();
        }

        // Error codes
        if (wsdlEpData.getEperrorCodes() != null) {
            errorCode = wsdlEpData.getEperrorCodes().trim();
        }

        // Initial duration
        if (wsdlEpData.getEpDur() >= 0) {
            suspendDurationOnFailure = wsdlEpData.getEpDur();
        }

        // Max duration
        if (0 <= wsdlEpData.getEpmaxSusDuration() && wsdlEpData.getEpmaxSusDuration() < Long.MAX_VALUE) {
            maxDuration = wsdlEpData.getEpmaxSusDuration();
        }

        // Factor
        if (0 <= wsdlEpData.getEpsusProgFactor() && wsdlEpData.getEpsusProgFactor() >= 0.0) {
            factor = wsdlEpData.getEpsusProgFactor();
        }

        // TimeOut error code
        if (wsdlEpData.getEptimdedOutErrorCodes() != null) {
            timeOutErrorCode = wsdlEpData.getEptimdedOutErrorCodes().trim();
        }

        // Retry time out
        if (wsdlEpData.getEpretryTimeout() > 0) {
            retryTimeOut = wsdlEpData.getEpretryTimeout();
        }

        // Retry delay timeout
        if (wsdlEpData.getEpretryDelay() > 0) {
            retryDelayTimeOut = wsdlEpData.getEpretryDelay();
        }

        // Action
        if (wsdlEpData.getEpwsdlTimeoutAction() == 100) { // TODO-remove magic number
            isNeverTimeout = true;
        } else if (wsdlEpData.getEpwsdlTimeoutAction() == 101) { // TODO-remove magic number
            isDiscardMessage = true;
            actionDuration = wsdlEpData.getEpactionDuration();
        } else {
            isFaultSequence = true;
            actionDuration = wsdlEpData.getEpactionDuration();
        }

        if (isDiscardMessage || isFaultSequence) {
            isNeverTimeout = false;
        }

        // Enable WS-Addressing?
        if (wsdlEpData.getEpaddressingOn()) {
            isEnableAddressing = true;
        }

        // Use seperate listener ?
        if (wsdlEpData.getEpwsaddSepListener()) {
            isSepListener = true;
        }

        // Enable WS-Sec?
        if (wsdlEpData.getEpsecutiryOn()) {
            isEnableWSSec = true;
            // Sec. policy
            if (wsdlEpData.getEpwsdlSecutiryKey() != null) {
                secPolicy = wsdlEpData.getEpwsdlSecutiryKey();
            }
        }

        // Enable rm ?
        if (wsdlEpData.getEprelMesg()) {
            isEnableRM = true;
            // RM. policy
            if (wsdlEpData.getEprmKey() != null) {
                rmPolicy = wsdlEpData.getEprmKey();
            }
        }
    }
%>
<script type="text/javascript" src="js/WSDLendpoint.js"></script>
<script type="text/javascript" src="js/endpoint-util.js"></script>

<script type="text/javascript">

    // invoke when saving WSDL data
    function submitEndpointData(isAnonymous) {
        if (!isValidAddressORWSDLEndpoint(isAnonymous, 'wsdl')) {
            return false;
        }
        document.wsdlEndpointForm.action = 'saveEndpoint.jsp?endpointType=WSDLEndpoint';
        document.wsdlEndpointForm.submit();
        return true;
    }

    function submitDynamicEndpointData() {
        if (!isValidAddressORWSDLEndpoint(true, 'wsdl')) {
            return false;
        }

        var key = document.getElementById('synRegKey').value;
        if (key == '') {
            CARBON.showWarningDialog('<fmt:message key="empty.key.field"/>');
            return false;
        }
        document.wsdlEndpointForm.action = 'saveDynamicEndpoint.jsp?endpointType=WSDLEndpoint&regKey=' + key;
        document.wsdlEndpointForm.submit();
        return true;
    }

    function switchToSource(isAnonymous) {
        if (!isValidAddressORWSDLEndpoint(isAnonymous, 'wsdl')) {
            return false;
        }
        document.wsdlEndpointForm.action = 'endpointSourceView.jsp?endpointType=WSDLEndpoint&ordinal=1';
        document.wsdlEndpointForm.submit();
        return true;
    }

    function showSaveAsForm(show) {
        var formElem = document.getElementById('saveAsForm');
        if (show) {
            formElem.style.display = "";
            var keyField = document.getElementById('synRegKey');
            if (keyField.value == '') {
                keyField.value = document.getElementById("endpointName").value;
            }
        } else {
            formElem.style.display = "none";
        }
    }


</script>

<div id="middle">
<h2><fmt:message key="wsdl.endpoint"/></h2>

<div id="workArea">
<form id="wsdlEnpointFormId" name="wsdlEndpointForm" action="" method="POST">
<table class="styledLeft">
<thead>
<tr>
    <th><span style="float: left; position: relative; margin-top: 2px;">
                            <fmt:message key="design.view.of.the.wsdl.endpoint"/></span>
        <a class="icon-link"
           style="background-image: url(images/source-view.gif);"
           onclick="switchToSource('<%=isAnonymous%>')"
           href="#"><fmt:message key="switch.to.source.view"/></a>
    </th>
</tr>
</thead>
<tbody>
<tr>
<td>
<table class="normal-nopadding">
<tbody>

<tr style="<%=!isAnonymous?"":"display:none"%>">
    <td><fmt:message key="endpointName"/> <span
            class="required">*</span></td>
    <td><input id="endpointName" name="endpointName"
               value="<%=wsdlEpName%>"
            <%=(!"".equals(wsdlEpName)) ? "disabled=\"disabled\"" : ""%>
               onkeypress="return validateText(event);"/>
        <input type="hidden" name="endpointName" value="<%=wsdlEpName%>"/>
    </td>
</tr>

<tr>
    <td class="leftCol-small"><fmt:message key="specify.as"/></td>
    <td><input type="radio" id="inlineWSDL" name="inlineWSDL" value="inlineWSDL"
               onclick="displayinLineWSDLArea()" <%=isInlineWSDL ? "checked=\"checked\"" : ""%>/>
        <fmt:message key="in.lined.wsdl"/>
        <input type="radio" id="uriWSDL" name="inlineWSDL" value="uriWSDL"
               onclick="displayWSDLURI()" <%=!isInlineWSDL ? "checked=\"checked\"" : ""%> />
        <fmt:message key="uri"/>
    </td>
</tr>
<tr id="inLineWSDLID" style="<%=isInlineWSDL?"":"display:none;"%>">
    <td class="leftCol-small"></td>
    <td><textarea id="inlineWSDLVal" name="inlineWSDLVal" rows="10"
                  cols="50"><%=isInlineWSDL ? inlineWSDl : ""%>
    </textarea>
    </td>
</tr>
<tr id="wsdlURIID" style="<%=!isInlineWSDL?"":"display:none;"%>">
    <td class="leftCol-small">
        <fmt:message key="wsdl.uri"/> <span class="required">*</span>
    </td>
    <td>
        <input type="text" id="uriWSDLVal" name="uriWSDLVal"
               value="<%=!isInlineWSDL?wsdlURI:""%>"/>
    </td>
</tr>

<tr>
    <td class="leftCol-small"><fmt:message key="service"/> <span
            class="required">*</span></td>
    <td><input id="wsdlendpointService" name="wsdlendpointService"
               value="<%=service%>"
               onkeypress="return validateText(event);"/>
    </td>
</tr>

<tr>
    <td><fmt:message key="port"/> <span
            class="required">*</span></td>
    <td><input id="wsdlendpointPort" name="wsdlendpointPort"
               value="<%=port%>"
               onkeypress="return validateText(event);"/>
    </td>
</tr>

<tr>
    <td colspan="2" class="sub-header"><fmt:message
            key="suspend"/></td>
</tr>
<tr>
    <td><fmt:message key="error.codes"/></td>
    <td><input type="text" id="suspendErrorCode" name="suspendErrorCode"
               value="<%=errorCode%>"/>
    </td>
</tr>
<tr>
    <td><fmt:message key="intial.duration.millis"/></td>
    <td><input type="text" id="suspendDuration" name="suspendDuration"
               value="<%=suspendDurationOnFailure==0?"":suspendDurationOnFailure %>"/>
    </td>
</tr>
<tr>
    <td><fmt:message key="max.duration.millis"/></td>
    <td><input type="text" id="suspendMaxDuration" name="suspendMaxDuration"
               value="<%=maxDuration==0?"":maxDuration%>"/>
    </td>
</tr>
<tr>
    <td><fmt:message key="factor"/></td>
    <td><input type="text" id="factor" name="factor"
               value="<%=(factor==0)?"":factor%>"/>
    </td>
</tr>

<tr>
    <td colspan="2" class="sub-header"><fmt:message
            key="on.timedout"/></td>
</tr>
<tr>
    <td><fmt:message key="error.codes"/></td>
    <td><input type="text" id="retryErroCode" name="retryErroCode"
               value="<%=timeOutErrorCode%>"/>
    </td>
</tr>
<tr>
    <td><fmt:message key="retry"/></td>
    <td><input type="text" id="retryTimeOut" name="retryTimeOut"
               value="<%=retryTimeOut%>"/>
    </td>
</tr>
<tr>
    <td><fmt:message key="retry.delay.millis"/></td>
    <td><input type="text" id="retryDelay" name="retryDelay"
               value="<%=retryDelayTimeOut%>"/>
    </td>
</tr>

<tr>
    <td colspan="2" class="sub-header"><fmt:message key="timeout"/></td>
</tr>
<tr>
    <td>
        <div class="indented"><fmt:message key="action"/></div>
    </td>
    <td><select name="actionSelect" onchange="activateDurationField(this)">
        <option value="<%=actionOptions[0]%>" <%=isNeverTimeout ? "selected=\"selected\"" : ""%>>
            <fmt:message key="action.never.timeout"/></option>
        <option value="<%=actionOptions[1]%>" <%=isDiscardMessage ? "selected=\"selected\"" : ""%>>
            <fmt:message key="action.discard.message"/></option>
        <option value="<%=actionOptions[2]%>" <%=isFaultSequence ? "selected=\"selected\"" : ""%>>
            <fmt:message key="action.execute.fault.sequence"/></option>
    </select></td>
</tr>
<tr>
    <td>
        <div class="indented"><fmt:message key="duration.millis"/>
        </div>
    </td>
    <td><input id="actionDuration" type="text" name="actionDuration"
               value="<%=actionDuration%>"
        <%=actionDuration == 0 ? "disabled=\"disabled\"" : ""%>
    </td>
</tr>

<tr>
    <td colspan="2" class="sub-header"><fmt:message key="qos"/></td>
</tr>
<tr>
    <td><fmt:message key="ws.addressing"/></td>
    <td><input type="checkbox" id="wsAddressing" name="wsAddressing"
        <%=isEnableAddressing ? "checked=\"checked\"" : ""%>
    </td>
</tr>
<tr>
    <td>
        <div class="indented"><fmt:message
                key="seperate.listener"/></div>
    </td>
    <td><input type="checkbox" id="sepListener" name="sepListener"
        <%=isSepListener ? "checked=\"checked\"" : ""%>
    </td>
</tr>
<tr>
    <td><fmt:message key="ws.security"/></td>
    <td><input type="checkbox" id="wsSecurity" name="wsSecurity"
            <%=isEnableWSSec ? "checked=\"checked\"" : ""%> /></td>
</tr>
<tr>
    <td>
        <div class="indented"><fmt:message key="policy.key"/></div>
    </td>
    <td>
        <table class="normal">
            <tr>
                <td>
                    <input class="longInput" type="text" id="wsSecPolicyKeyID"
                           name="wsSecPolicyKeyID"
                           value="<%=secPolicy%>" disabled="true"/>
                    <input type="hidden" id="wsSecPolicyKeyID_hidden"
                           name="wsSecPolicyKeyID_hidden"
                           value="<%=secPolicy%>"/>
                </td>
                <td>
                    <a href="#registryBrowserLink"
                       class="registry-picker-icon-link"
                       style="padding-left:40px"
                       onclick="showInLinedRegistryBrowser('wsSecPolicyKeyID')"><fmt:message
                            key="registry.keys"/></a>
                </td>
            </tr>
        </table>

    </td>
</tr>
<tr>
    <td><fmt:message key="ws.rm"/></td>
    <td><input type="checkbox" id="wsRM" name="wsRM"
            <%=isEnableRM ? "checked=\"checked\"" : ""%> /></td>
</tr>
<tr>
    <td>
        <div class="indented"><fmt:message
                key="policy.key"/></div>
    </td>
    <td>
        <table class="normal">
            <tr>
                <td><input class="longInput" type="text" id="wsrmPolicyKeyID"
                           name="wsrmPolicyKeyID"
                           value="<%=rmPolicy%>" disabled="true"/>
                    <input type="hidden" id="wsrmPolicyKeyID_hidden"
                           name="wsrmPolicyKeyID_hidden"
                           value="<%=rmPolicy%>"/>
                </td>
                <td><a href="#registryBrowserLink"
                       class="registry-picker-icon-link"
                       style="padding-left:40px"
                       onclick="showInLinedRegistryBrowser('wsrmPolicyKeyID')"><fmt:message
                        key="registry.keys"/></a></td>
            </tr>
        </table>
    </td>
</tr>

<tr>
    <td class="buttonRow" colspan="2">
        <input type="button" value="<fmt:message key="save"/>" class="button" name="save"
               onclick="submitEndpointData('<%=isAnonymous%>');"/>
        <%
            if (!isAnonymous)  {
        %>
            <input type="button" value="<fmt:message key="saveas"/>" class="button" name="save"
                   onclick="javascript:showSaveAsForm(true);"/>
        <%
            }
        %>
        <input type="button" value="<fmt:message key="cancel"/>" name="cancel" class="button"
               onclick="cacelEndpointData('<%=anonymouseOriginator%>');"/>
    </td>
</tr>
</tbody>


</table>
<div style="display:none;" id="saveAsForm">
    <p>&nbsp;</p>
    <table class="styledLeft">
        <thead>
        <tr>
            <th colspan="2">
                <span style="float:left; position:relative; margin-top:2px;"><fmt:message key="save.as.title"/></span>
            </th>
        </tr>
        </thead>
        <tbody>
        <tr>
            <td>
                <table class="normal">
                    <tr>
                        <td>Key</td>
                        <td><input type="text" size="75" id="synRegKey"/></td>
                    </tr>
                </table>
            </td>
        </tr>
        <tr>
            <td class="buttonRow">
                <input type="button" class="button" value="<fmt:message key="save"/>" id="saveSynRegButton" onclick="javascript:submitDynamicEndpointData(); return false;"/>
                <input type="button" class="button" value="<fmt:message key="cancel"/>" id="cancelSynRegButton" onclick="javascript:showSaveAsForm(false); return false;">
            </td>
        </tr>
        </tbody>
    </table>
</div>
</td>
</tr>
</tbody>
</table>
</form>
</div>
</div>
<a name="registryBrowserLink"></a>
</fmt:bundle>