<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>

<%@page contentType="text/html" pageEncoding="UTF-8"
        import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.wso2.carbon.endpoint.tos.xsd.EndpointMetaData" %>
<%@ page import="org.wso2.carbon.endpoint.ui.client.EndpointAdminClient" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.CarbonError" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<link type="text/css" rel="stylesheet" href="css/menu.css"/>
<link type="text/css" rel="stylesheet" href="css/style.css"/>

<!-- Dependencies -->
<script type="text/javascript" src="../yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="../yui/build/container/container_core-min.js"></script>

<!-- Connection handling lib -->
<script type="text/javascript" src="../yui/build/yahoo/yahoo-min.js"></script>
<script type="text/javascript" src="../yui/build/event/event-min.js"></script>
<script type="text/javascript" src="../yui/build/connection/connection-min.js"></script>
<script type="text/javascript" src="../resources/js/resource_util.js"></script>
<!-- Source File -->

<script type="text/javascript" src="../yui/build/menu/menu-min.js"></script>


<fmt:bundle basename="org.wso2.carbon.endpoints.ui.i18n.Resources">
<carbon:breadcrumb
        label="endpoints"
        resourceBundle="org.wso2.carbon.endpoints.ui.i18n.Resources"
        topPage="true"
        request="<%=request%>"/>

<%
    String endpointTyepes[] = {"Address Endpoint", "WSDL Endpoint", "Failover group",
            "Load-balance group"};
    String serverURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext = (ConfigurationContext) config.getServletContext().
            getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    EndpointAdminClient client = new EndpointAdminClient(cookie, serverURL, configContext);
    EndpointMetaData[] ePMetaData = null;
    CarbonError carbonError;
    try {
        ePMetaData = client.getEndpointMetaData();
    } catch (Exception e) {
        carbonError = new CarbonError();
        carbonError.addError("Unable to communicate with the back end server");
        request.setAttribute(CarbonError.ID, carbonError);
%>
<jsp:forward page="../admin/error.jsp"/>
<%
        return;

    }
    String endpointMode = null; // this holds an annonymos endpoint which can come trough proxy and send mediator
    String anonymouseOriginator = null;
    boolean isAnonymous = false;
    String anonymousEndpointXML = null;

    // came throuh clicking menu on the left
    if (request.getParameter("region") != null && request.getParameter("item") != null) {
        session.removeAttribute("epMode");
        session.removeAttribute("anonEpXML");
        session.removeAttribute("proxy");
        session.removeAttribute("header");
    } else {
        // a user is adding an anonymous endpoint
        endpointMode = (String) session.getAttribute("epMode");
        if (endpointMode != null && endpointMode.equals("anon")) {
            // if the user is here that means the user is going to add (not edit an existing endpoint)
            // a new endpoint
            isAnonymous = true;
            anonymouseOriginator = (String) session.getAttribute("anonOriginator");
        }
    }

%>
<script type="text/javascript">

    function enableStat(endpointName) {
        $.ajax({
            type: 'POST',
            url: 'stat-ajaxprocessor.jsp',
            data: 'endpointName=' + endpointName + '&action=enableStat',
            success: function(msg) {
                handleCallback('enableStat', endpointName);
            }
        });
    }

    function disableStat(endpointName) {
        $.ajax({
            type: 'POST',
            url: 'stat-ajaxprocessor.jsp',
            data: 'endpointName=' + endpointName + '&action=disableStat',
            success: function(msg) {
                handleCallback('disableStat', endpointName);
            }
        });
    }


    function handleCallback(action, endpointName) {
        var element;
        if (action == 'enableStat') {
            element = document.getElementById("disableStat" + endpointName);
            element.style.display = "";
            element = document.getElementById("enableStat" + endpointName);
            element.style.display = "none";
        } else {
            element = document.getElementById("disableStat" + endpointName);
            element.style.display = "none";
            element = document.getElementById("enableStat" + endpointName);
            element.style.display = "";
        }
    }

    function editEndpoint(endPointName, endPointType) {
        if (endPointType == 0) {
            document.location.href = 'addressEndpoint.jsp?endpointName=' + endPointName + '&endpointAction=edit';
        } else if (endPointType == 1) {
            document.location.href = 'WSDLEndpoint.jsp?endpointName=' + endPointName + '&endpointAction=edit';
        } else if (endPointType == 2) {
            document.location.href = 'failOverEndpoint.jsp?endpointName=' + endPointName + '&endpointAction=edit';
        } else if (endPointType == 3) {
            document.location.href = 'loadBalanceEndpoint.jsp?endpointName=' + endPointName + '&endpointAction=edit';
        }
    }

    function deleteEndpoint(endpointName) {
        CARBON.showConfirmationDialog("<fmt:message key="do.you.want.to.delete.the.endpoint"/> " + endpointName + " ?", function() {
            location.href = "deleteEndpoint.jsp?endpointName=" + endpointName;
        });
    }

    function goBack(orginiator) {
        if (orginiator == null) {
            alert('Error: where to go?');
            return false;
        }
        document.location.href = orginiator + '?cancelled=true';
        return true;
    }


</script>

<div id="middle">
    <h2><fmt:message key="manage.endpoints"/></h2>

    <div id="workArea">
        <div id="noEpDiv" style="<%=ePMetaData!=null || isAnonymous?"display:none":""%>">
            <fmt:message
                    key="no.endpoints.are.currently.defined.click.add.endpoint.to.define.a.new.endpoint"></fmt:message>

        </div>
        <% if (ePMetaData != null && !isAnonymous) {%>
        <table class="styledLeft" cellpadding="1" id="endpointListTable">
            <thead>
            <tr>
                <th><fmt:message key="endpoint.name"/></th>
                <th><fmt:message key="type"/></th>
                <th colspan="3"><fmt:message key="action"/></th>
            </tr>
            </thead>
            <tbody>
            <%for (EndpointMetaData endpoint : ePMetaData) {%>
            <tr>
                <td><%= endpoint.getName()%>
                </td>
                <td><%= endpointTyepes[endpoint.getType()]%>
                </td>

                <% // display stat icon only for Address and WSDL endpoint
                    if (endpointTyepes[endpoint.getType()].equals("Address Endpoint")
                            || endpointTyepes[endpoint.getType()].equals("WSDL Endpoint")) {
                        // TODO-we can avoid back end service call if we try setting this in session
                        if (endpoint.getEnableStatistics()) { %>
                <td style="border-right:none;border-left:none;width:200px">
                    <div class="inlineDiv">
                        <div id="disableStat<%= endpoint.getName()%>">
                            <a href="#" onclick="disableStat('<%= endpoint.getName() %>')"
                               class="icon-link"
                               style="background-image:url(../admin/images/static-icon.gif);"><fmt:message
                                    key="disable.statistics"/></a>
                        </div>
                        <div id="enableStat<%= endpoint.getName()%>" style="display:none;">
                            <a href="#" onclick="enableStat('<%= endpoint.getName() %>')"
                               class="icon-link"
                               style="background-image:url(../admin/images/static-icon-disabled.gif);"><fmt:message
                                    key="enable.statistics"/></a>
                        </div>
                    </div>
                </td>
                <%
                } else { %>
                <td style="border-right:none;border-left:none;width:200px">
                    <div class="inlineDiv">
                        <div id="enableStat<%= endpoint.getName()%>">
                            <a href="#" onclick="enableStat('<%= endpoint.getName() %>')"
                               class="icon-link"
                               style="background-image:url(../admin/images/static-icon-disabled.gif);"><fmt:message
                                    key="enable.statistics"/></a>
                        </div>
                        <div id="disableStat<%= endpoint.getName()%>" style="display:none">
                            <a href="#" onclick="disableStat('<%= endpoint.getName() %>')"
                               class="icon-link"
                               style="background-image:url(../admin/images/static-icon.gif);"><fmt:message
                                    key="disable.statistics"/></a>
                        </div>
                    </div>
                </td>

                <% }
                } else {%>
                <td></td>
                <%
                    }
                %>
                <td style="border-left:none;border-right:none;width:100px">
                    <div class="inlineDiv">
                        <a href="#"
                           onclick="editEndpoint('<%= endpoint.getName() %>','<%=endpoint.getType()%>')"
                           class="icon-link"
                           style="background-image:url(../admin/images/edit.gif);"><fmt:message
                                key="edit"/></a>
                    </div>
                </td>
                <td style="border-left:none;width:100px">
                    <div class="inlineDiv">
                        <a href="#" onclick="deleteEndpoint('<%= endpoint.getName() %>')"
                           class="icon-link"
                           style="background-image:url(../admin/images/delete.gif);"><fmt:message
                                key="delete"/></a>
                    </div>
                </td>
            </tr>
            <%}%>
            </tbody>
        </table>
        <%}%>

        <table id="endpointOptionTable">
            <tr>
                <td>
                    <a class="icon-link"
                       href="addressEndpoint.jsp"
                       style="background-image: url(../admin/images/add.gif);">
                        <fmt:message key="add.address.endpoint"/>
                    </a>
                </td>
            </tr>
            <tr>
                <td>
                    <a class="icon-link"
                       href="WSDLEndpoint.jsp"
                       style="background-image: url(../admin/images/add.gif);">
                        <fmt:message key="add.wsdl.endpoint"/>
                    </a>
                </td>
            </tr>
            <tr>
                <td>
                    <a class="icon-link"
                       href="failOverEndpoint.jsp"
                       style="background-image: url(../admin/images/add.gif);">
                        <fmt:message key="add.failover.endpoint1"/>
                    </a>
                </td>
            </tr>
            <tr>
                <td>
                    <a class="icon-link"
                       href="loadBalanceEndpoint.jsp"
                       style="background-image: url(../admin/images/add.gif);">
                        <fmt:message key="add.load.balance.group"/>
                    </a>
                </td>
            </tr>
            <tr>
                <td><br></td>
            </tr>
            <tr id="btnRow" style="<%=isAnonymous?"":"display:none"%>">
                <td colspan="2" class="buttonRow">
                    <input id="cancelBtn" type="button" value="<fmt:message key="back"/>"
                           class="button"
                           onclick="goBack('<%=anonymouseOriginator%>');return false"/>
                </td>
            </tr>
        </table>

    </div>
</div>
<script type="text/javascript">
    alternateTableRows('endpointListTable', 'tableEvenRow', 'tableOddRow');
</script>

</fmt:bundle>