<%--da
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0                                                           
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>                                      `
<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.apache.axiom.om.impl.llom.util.AXIOMUtil" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.synapse.config.xml.endpoints.EndpointFactory" %>
<%@ page import="org.apache.synapse.endpoints.LoadbalanceEndpoint" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.endpoint.tos.xsd.EndpointMetaData" %>
<%@ page import="org.wso2.carbon.endpoint.ui.client.EndpointAdminClient" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="javax.xml.stream.XMLStreamException" %>
<%@ page import="java.util.ResourceBundle" %>
<%@ page import="java.util.regex.Matcher" %>
<%@ page import="java.util.regex.Pattern" %>
<%@ page import="org.wso2.carbon.endpoint.ui.util.EndpointConfigurationHelper" %>
<%@ page import="org.apache.synapse.endpoints.SALoadbalanceEndpoint" %>
<%@ page import="org.apache.synapse.config.xml.endpoints.SALoadbalanceEndpointFactory" %>
<%@ page import="javax.xml.namespace.QName" %>
<%@ page import="org.apache.synapse.SynapseConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>


<link type="text/css" rel="stylesheet" href="css/style.css"/>
<link type="text/css" rel="stylesheet" href="css/menu.css"/>

<script type="text/javascript" src="../yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="../yui/build/container/container_core-min.js"></script>
<script type="text/javascript" src="../yui/build/yahoo/yahoo-min.js"></script>
<script type="text/javascript" src="../yui/build/event/event-min.js"></script>
<script type="text/javascript" src="../yui/build/connection/connection-min.js"></script>
<script type="text/javascript" src="../yui/build/menu/menu-min.js"></script>
<script type="text/javascript" src="../resources/js/resource_util.js"></script>

<%
    String[] sesssionManOptions = {"SelectAValue", "http", "soap", "simpleClientSession"};
    ResourceBundle bundle = ResourceBundle.getBundle("org.wso2.carbon.sequences.ui.i18n.Resources", request.getLocale());
    String url = CarbonUIUtil.getServerURL(this.getServletConfig().getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().
                    getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    EndpointAdminClient adminClient = new EndpointAdminClient(cookie, url, configContext);
    String loadBalanceData = null;

    String endpointName = request.getParameter("endpointName");
    String endpointAction = request.getParameter("endpointAction");
    String design = request.getParameter("design");

    String endpointMode = null; // this holds an annonymos endpoint which can come trough proxy and send mediator
    String anonymouseOriginator = null;
    boolean isAnonymous = false;
    String anonymousEndpointXML = null;
    endpointMode = (String) session.getAttribute("epMode");
    if (endpointMode != null && "anon".equals(endpointMode)) {
        isAnonymous = true;
    }

    // coming through index.jsp by clicking the 'edit' link
    if (endpointAction != null && !"".equals(endpointAction) && endpointAction.equals("edit")) {
        session.setAttribute("edit" + endpointName, "edit"); // uses when saving the endpoint
        if (endpointName != null) {
            try {
                loadBalanceData = adminClient.getEndpoint(endpointName);
            } catch (Exception e) {
                String msg = "Unable to get loadBalance Endpoint data: " + e.getMessage();
                CarbonUIMessage.sendCarbonUIMessage(msg, CarbonUIMessage.ERROR, request);
            }
        }

    } else if (design != null && !"".equals(design)) {
        // coming through source view using switchToDesign
        loadBalanceData = design.replaceAll("\\s\\s+|\\n|\\r", ""); // remove the pretty printing from the string
        loadBalanceData = EndpointConfigurationHelper.getValidStringXMlStringForAMP(loadBalanceData);
        
    } else if (isAnonymous) {
        // coming through using either send mediator or proxy services by adding an annonymous endpoint
        //we are in anonymous mode
        anonymouseOriginator = (String) session.getAttribute("anonOriginator");
        anonymousEndpointXML = (String) session.getAttribute("anonEpXML");
        if (anonymousEndpointXML != null && !"".equals(anonymousEndpointXML)) {
            // if a user is here that mean user is trying to edit an existing anoymous endpoint
            try {
                loadBalanceData = EndpointAdminClient.getAnonEpXMLwithName(anonymousEndpointXML);
            } catch (XMLStreamException e) {
                session.removeAttribute("anonEpXML");
%>
<script type="text/javascript">
    CARBON.showErrorDialog("Unable to create endpoint with given data");
    window.location.href = "loadBalanceEndpoint.jsp";
</script>
<%
            }
        }
    }

    // if load balance data is null that mean user is adding a new failOver endpoint
    String loadBalanceEndpointName = "";
    boolean isDefault = true, isTransport = false, isSOAP = false, isClientID = false;
    long sessionTimeout = 0;
    SALoadbalanceEndpoint saloadBalanceDataElement = null;
    LoadbalanceEndpoint loadBalacneDataElement = null;
    if (loadBalanceData != null) {
        String formattedEpDate;
        Pattern pattern = Pattern.compile("\\s+");
        Matcher matcher = pattern.matcher(loadBalanceData);
        formattedEpDate = "" + matcher.replaceAll(" ") + "\r\n";
        formattedEpDate = formattedEpDate.trim();
        OMElement element = null;

        try {
            // we have a omelement of the endpoint configuration
            element = AXIOMUtil.stringToOM(formattedEpDate);
        } catch (XMLStreamException e) {
            String msg = "Unable to create OMElement data: " + e.getMessage();
            CarbonUIMessage.sendCarbonUIMessage(msg, CarbonUIMessage.ERROR, request);
        }
        if (SALoadbalanceEndpointFactory.getEndpointFromElement(element, false) instanceof SALoadbalanceEndpoint) {
            saloadBalanceDataElement = (SALoadbalanceEndpoint) SALoadbalanceEndpointFactory.getEndpointFromElement(element, false);
        } else {
            loadBalacneDataElement = (LoadbalanceEndpoint) EndpointFactory.getEndpointFromElement(element, false);
        }
        if (saloadBalanceDataElement != null) {
            loadBalanceEndpointName = saloadBalanceDataElement.getName(); // TODO NPE ?
            sessionTimeout = saloadBalanceDataElement.getSessionTimeout();  // TODO NPE ?
            OMElement sessionElement = element.getFirstChildWithName(new QName(SynapseConstants.SYNAPSE_NAMESPACE, "session"));
            String sessionType = sessionElement.getAttributeValue(new QName(null, "type"));
            if (sessionType != null && !"".equals(sessionType)) {
                if (sessionType.equals("http")) {
                    isTransport = true;
                    isDefault = false;
                } else if (sessionType.equals("soap")) {
                    isSOAP = true;
                    isDefault = false;
                } else if (sessionType.equals("simpleClientSession")) {
                    isClientID = true;
                    isDefault = false;
                }
            }
        } else if (loadBalacneDataElement != null) {
            loadBalanceEndpointName = loadBalacneDataElement.getName();
            isDefault = true;
        }
    }
%>

<script type="text/javascript" src="js/addressEndpoint.js"></script>
<script type="text/javascript" src="js/WSDLendpoint.js"></script>
<script type="text/javascript" src="js/fo-lb-endpoint-util.js"></script>
<script type="text/javascript" src="js/endpoint-util.js"></script>
<script type="text/javascript" src="js/endpoint-form.js"></script>
<script type="text/javascript">
    // the saved endpoint confiuration which is used to generate the design view if available
    var endpointConfiguration = '<%=loadBalanceData%>';

    // keep track  the adding endpoint configuration
    var doc;

    // We are dealing with failOver type
    var mainType = 'load';

    // inilize the 'doc' above
    initDoc();

    //This is the variable use to keep the selected tag in the browser
    var selectedFlag = mainType + '.0';

    //Creating the menu
    var oMenu;
    createMenu();

    // once the document is ready starting from initilazing the endpoints
    jQuery(document).ready(function() {
        initEndpoints();
    });

    function submitEndpointData(isAnonymous) {
        // update load balance endpoint name etc..
        if (isAnonymous == 'false') {
            var endpointName = document.getElementById('load.name').value;
            getNodeById("load.0").setAttribute('name', endpointName);
        }
        var childNode = getNodeById('load.0');
        if (!updateLoadBalanceEndpoint('', childNode)) {
            CARBON.showWarningDialog(jsi18n['error.updating.the.configuration']);
            return false;
        }

        var loadBalanceConfDoc = cleanIDs(doc);
        var lodaBalanceConfString = xmlToString(loadBalanceConfDoc);

        document.loadBalanceEndpointForm.action = 'saveEndpoint.jsp?endpointType=loadBalanceEndpoint';
        document.loadBalanceEndpointForm.loadBalanceConf.value = lodaBalanceConfString;
        document.loadBalanceEndpointForm.submit();
        return true;
    }

    function submitDynamicEndpointData() {
        var key = document.getElementById('synRegKey').value;
        if (key == '') {
            CARBON.showWarningDialog(jsi18n['empty.key.field']);
            return false;
        }
        
        var endpointName = document.getElementById('load.name').value;
        getNodeById("load.0").setAttribute('name', endpointName);
        var childNode = getNodeById('load.0');
        if (!updateLoadBalanceEndpoint('', childNode)) {
            CARBON.showWarningDialog(jsi18n['error.updating.the.configuration']);
            return false;
        }

        var loadBalanceConfDoc = cleanIDs(doc);
        var lodaBalanceConfString = xmlToString(loadBalanceConfDoc);

        document.loadBalanceEndpointForm.action = 'saveDynamicEndpoint.jsp?endpointType=loadBalanceEndpoint&regKey=' + key;
        document.loadBalanceEndpointForm.loadBalanceConf.value = lodaBalanceConfString;
        document.loadBalanceEndpointForm.submit();
        return true;
    }

    function switchToSource(isAnonymous) {
        // update load balance endpoint name etc..
        if (isAnonymous == 'false') {
            var endpointName = document.getElementById('load.name').value;
            getNodeById("load.0").setAttribute('name', endpointName);
        }
        var childNode = getNodeById('load.0');
        if (!updateLoadBalanceEndpoint('', childNode)) {
            CARBON.showWarningDialog(jsi18n['error.updating.the.configuration']);
            return false;
        }

        var loadBalanceConfDoc = cleanIDs(doc);
        var lodaBalanceConfString = xmlToString(loadBalanceConfDoc);

        document.loadBalanceEndpointForm.action = 'endpointSourceView.jsp?endpointType=loadBalanceEndpoint&retainlastbc=true';
        document.loadBalanceEndpointForm.loadBalanceConf.value = lodaBalanceConfString;
        document.loadBalanceEndpointForm.submit();
        return true;
    }

    function showSaveAsForm(show) {
        var formElem = document.getElementById('saveAsForm');
        if (show) {
            formElem.style.display = "";
            var keyField = document.getElementById('synRegKey');
            if (keyField.value == '') {
                keyField.value = document.getElementById('load.name').value;
            }
        } else {
            formElem.style.display = "none";
        }
    }

</script>

<fmt:bundle basename="org.wso2.carbon.endpoints.ui.i18n.Resources">
    <carbon:jsi18n
            resourceBundle="org.wso2.carbon.endpoints.ui.i18n.Resources"
            request="<%=request%>"/>
    <carbon:breadcrumb
            label="design.view.of.the.load.balance.endpoint"
            resourceBundle="org.wso2.carbon.endpoints.ui.i18n.Resources"
            topPage="false"
            request="<%=request%>"/>
    <div id="middle">
        <h2><fmt:message key="design.view.of.the.load.balance.endpoint"/></h2>

        <div id="workArea">
            <form id="loadBalanceEndpointForm" name="loadBalanceEndpointForm" action=""
                  method="POST">
                <input type="hidden" id="loadBalanceConf" name="loadBalanceConf" value=""/>
                <table class="styledLeft" cellspacing="0">
                    <thead>
                    <tr>
                        <th>
                        <span style="float: left; position: relative; margin-top: 2px;"><fmt:message
                                key="design.view.of.the.load.balance.endpoint"/></span>
                            <a href="#" onclick="switchToSource('<%=isAnonymous%>');" class="icon-link"
                               style="background-image: url(images/source-view.gif);"><fmt:message
                                    key="switch.to.source.view"/></a>
                        </th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr>
                        <td>
                            <table class="normal" width="100%">
                                <tr style="<%=!isAnonymous?"":"display:none"%>">
                                    <td class="leftCol-small">
                                        <fmt:message key="endpoint.name"/> <span
                                            class="required">*</span>
                                    </td>
                                    <td>
                                        <input type="text" id="load.name"
                                               value="<%=loadBalanceEndpointName %>" <%= "edit".equals(endpointAction) ? "disabled=\"disabled\"" : "" %>
                                               onkeypress="return validateText(event);"/>
                                        <input type="hidden" name="endpointName"
                                               value="<%=loadBalanceEndpointName%>"/>
                                        <input type="hidden" name="isAnnonEndpointID"
                                               id="isAnnonEndpointID" value="<%=isAnonymous%>"/>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="leftCol-small"><fmt:message
                                            key="session.management"/></td>
                                    <td><select name="sessionManagement" id="_sesOptions"
                                                onchange="activateManagementField(this)">
                                        <option value="<%=sesssionManOptions[0]%>" <%=isDefault ? "selected" : ""%>>
                                            <fmt:message key="none"/></option>
                                        <option value="<%=sesssionManOptions[1]%>" <%=isTransport ? "selected" : ""%>>
                                            <fmt:message key="transport"/></option>
                                        <option value="<%=sesssionManOptions[2]%>" <%=isSOAP ? "selected" : ""%>>
                                            <fmt:message key="soap"/></option>
                                        <option value="<%=sesssionManOptions[3]%>" <%=isClientID ? "selected" : ""%>>
                                            <fmt:message key="client.id"/></option>
                                    </select></td>
                                </tr>
                                <tr>
                                    <td class="leftCol-small">
                                        <fmt:message key="endpoint.session.timeout"/>
                                    </td>
                                    <td>
                                        <input type="text" id="_sessionTimeOut"
                                               value="<%= sessionTimeout%>"
                                                <%=sessionTimeout == 0 ? "disabled=\"disabled\"" : ""%>
                                               onkeypress="return validateText(event);"/>
                                    </td>
                                </tr>
                                <tr>
                                    <td colspan="3">
                                        <div class="treePane" id="treePane"
                                             style="height: 300px; overflow: auto; width: auto; border: 1px solid rgb(204, 204, 204);position:relative;">
                                            <div style="position:absolute;padding:20px;">
                                                <ul class="root-list" id="failoverTree">
                                                    <li>
                                                        <div class="minus-icon"
                                                             onclick="treeColapse(this)"
                                                             id="treeColapser"></div>
                                                        <div class="endpoints" id="load.0">
                                                            <a class="root-endpoint"><fmt:message
                                                                    key="endpoint.root"/></a>

                                                            <div class="sequenceToolbar"
                                                                 style="width:100px;">
                                                                <div>
                                                                    <a class="addChildStyle"><fmt:message
                                                                            key="add.endpoint"/></a>
                                                                </div>
                                                            </div>
                                                        </div>

                                                    </li>
                                                </ul>
                                            </div>
                                        </div>
                                    </td>
                                </tr>
                            </table>
                            <div id="endpointDesign" style="display:none">
                                <table class="normal" width="100%">
                                    <tr>
                                        <td>
                                            <table class="styledLeft" cellspacing="0">
                                                <tr>
                                                    <td class="middle-header">
                                            <span style="float:left;position:relative; margin-top:2px;">
                                                <fmt:message
                                                        key="design.view.of.the.endpoint"/></span>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td style="padding: 0px !important;">
                                                        <div id="info" class="tabPaneContentMain"
                                                             style="width:auto;padding:0px;"></div>
                                                    </td>
                                                </tr>
                                            </table>
                                        </td>
                                    </tr>
                                </table>
                            </div>

                        </td>
                    </tr>
                    <tr>
                        <td class="buttonRow">
                            <input type="button" value="<fmt:message key="save"/>"
                                   class="button"
                                   name="save"
                                   onclick="submitEndpointData('<%=isAnonymous%>');"/>
                            <%
                                if (!isAnonymous)  {
                            %>
                            <input type="button" value="<fmt:message key="saveas"/>" class="button" name="save"
                                   onclick="javascript:showSaveAsForm(true);"/>
                            <%
                                }
                            %>
                            <input type="button" value="<fmt:message key="cancel"/>"
                                   name="cancel"
                                   class="button"
                                   onclick="cacelEndpointData('<%=anonymouseOriginator%>');"/>
                        </td>
                    </tr>
                    </tbody>
                </table>
<div style="display:none;" id="saveAsForm">
    <p>&nbsp;</p>
    <table class="styledLeft">
        <thead>
        <tr>
            <th colspan="2">
                <span style="float:left; position:relative; margin-top:2px;"><fmt:message key="save.as.title"/></span>
            </th>
        </tr>
        </thead>
        <tbody>
        <tr>
            <td>
                <table class="normal">
                    <tr>
                        <td><fmt:message key="registry.key"/></td>
                        <td><input type="text" size="75" id="synRegKey"/></td>
                    </tr>
                </table>
            </td>
        </tr>
        <tr>
            <td class="buttonRow">
                <input type="button" class="button" value="<fmt:message key="save"/>" id="saveSynRegButton" onclick="javascript:submitDynamicEndpointData(); return false;"/>
                <input type="button" class="button" value="<fmt:message key="cancel"/>" id="cancelSynRegButton" onclick="javascript:showSaveAsForm(false); return false;">
            </td>
        </tr>
        </tbody>
    </table>
</div>
            </form>
        </div>
    </div>


</fmt:bundle>
