<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>

<%@page contentType="text/html" pageEncoding="UTF-8"
        import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.endpoint.tos.xsd.EndpointMetaData" %>
<%@ page import="org.wso2.carbon.endpoint.ui.client.EndpointAdminClient" %>
<%@ page import="org.wso2.carbon.endpoint.ui.util.EndpointConfigurationHelper" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>


<%
    boolean isError = false;
    String url = CarbonUIUtil.getServerURL(this.getServletConfig().getServletContext(),
            session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    EndpointAdminClient client = new EndpointAdminClient(cookie, url, configContext);

    EndpointConfigurationHelper epConfigHelper = new EndpointConfigurationHelper();

    // there are two ways to hit these page.1. By clicking save in design view 2. By clicking saven in
    // source view

    String forwardTo = "../endpoints/index.jsp?region=region1&item=endpoints_menu";
    String sourceViewXML = request.getParameter("design");
    String endpointType = request.getParameter("endpointType");
    String endpointName = request.getParameter("endpointName");

    String endpointMode = null; // this holds an annonymos endpoint which can come trough proxy and send mediator
    String anonymouseOriginator = null;
    boolean isAnonymous = false;
    String anonymousEndpointXML = null;
    String rawConfString;
    endpointMode = (String) session.getAttribute("epMode");
    if (endpointMode != null && "anon".equals(endpointMode)) {
        isAnonymous = true;
    }

    String endpointAction = (String) session.getAttribute("edit" + endpointName);
    String configuration = null;

    // came through source -> save
    if (sourceViewXML != null && !"".equals(sourceViewXML)) {
        configuration = sourceViewXML.replaceAll("\\s\\s+|\\n|\\r", ""); // remove the pretty printing from the string

    } else { // came through design-> save
        // build and save each and every configuration
        if (endpointType.equals("addressEndpoint") && !"".equals("addressEndpoint")) {
            configuration = EndpointConfigurationHelper.buildAddressOrWSDLEpConfiguration(request, endpointType, isAnonymous);

        } else if (endpointType.equals("WSDLEndpoint") && !"".equals("WSDLEndpoint")) {
            configuration = EndpointConfigurationHelper.buildAddressOrWSDLEpConfiguration(request, endpointType, isAnonymous);

        } else if (endpointType.equals("loadBalanceEndpoint") && !"".equals("loadBalanceEndpoint")) {
            rawConfString = request.getParameter("loadBalanceConf");
            configuration = rawConfString.replaceAll("\\s\\s+|\\n|\\r", "");// this to ensure  that the final configuration doesn't have any spaces etc..

        } else if (endpointType.equals("failOverEndpoint") && !"".equals("failOverEndpoint")) {
            rawConfString = request.getParameter("failOverConf");
            configuration = rawConfString.replaceAll("\\s\\s+|\\n|\\r", ""); // this to ensur that the final configuration doesn't have any spaces etc..
        }
    }

    if (endpointMode == null) {
        try {
            if (endpointAction != null && endpointAction.equals("edit") && !"".equals(endpointAction)) {
                // save an existing one
                client.saveEndpoint(configuration);
//                session.removeAttribute("endpointAction"); // we no more need this
            } else {
                //add a new endpoint
                client.addEndpoint(configuration);
            }
        } catch (Exception e) {
            isError = true;
            String errMsg = e.getMessage();
            errMsg = errMsg.replace("\'", ""); // this is to ensure that error message doesn't have ' or " marking unterminated strings
            errMsg = errMsg.replace("\"", "");
            errMsg = errMsg.replace("\n", "");
%>
<script type="text/javascript">
    jQuery(document).ready(function() {
        function gotoPage() {
            history.go(-1);
        }

        CARBON.showErrorDialog('<%=errMsg%>', gotoPage);
    });
</script>
<%
        }
    } else if (isAnonymous) {
        // coming through using either send mediator or proxy services by adding an annonymous endpoint
        // we are in anonymous mode
        anonymouseOriginator = (String) session.getAttribute("anonOriginator");
        request.setAttribute("endpointName", "anon"); // set the endpoint name to Annonymous
        session.setAttribute("anonEpXML", configuration);
        forwardTo = anonymouseOriginator + "?originator=../endpoints/saveEndpoint.jsp";
    }

    if (!isError) {
%>
<script type="text/javascript">
    // just forward to relevent page if there is no error
    document.location.href = '<%=forwardTo%>'; //TODO-use JQuery AJAX here
</script>
<%
    }
%>
